/* Reference :
Tiihonen, J., Soininen, T., Niemela, I., Sulonen, R.:
 Empirical testing of a weight constraint rule based configurator. 
In ECAI 2002 Configuration Workshop. (2002) 17--22 
http://www.soberit.hut.fi/pdmg/Empirical/index.html

 File: fx.pm
 Desc:  ILOG instance for FX Benchmark
 Auth: Sathi
 Date: Mon July 12 2004
*/


variable

public Control_type:[0..2];
public Supply_voltage_and_frequency:[0..5];
public Control_type_and_Nominal_Power:[0..4];
public Supply_voltage:[0..3];
public Supply_frequency:[0..1];
public Pressure:[0..3];
public Nominal_power:[0..3];
public Maximum_capacity:[0..43];
public Document_language:[0..8];
public Week_timer:[0..1];
public Communication_bus_RS485:[0..1];
public Canopy_filter:[0..1];
public Integrated_refridgeration_air_dryer:[0..1];
public Oil_water_separator:[0..1];
public Water_draining_system:[0..2];
public Maximum_ambient_temperature:[0..2];
public Altitude:[0..1];
public Packaging:[0..4];

rule

(Control_type_and_Nominal_Power = 0)->((Control_type = 1) and (Nominal_power = 0));
(Control_type_and_Nominal_Power = 1)->((Control_type = 1) and (Nominal_power = 1));
(Control_type_and_Nominal_Power = 2)->((Control_type = 1) and (Nominal_power = 2));
(Control_type_and_Nominal_Power = 3)->((Control_type = 2) and (Nominal_power = 0));
(Control_type_and_Nominal_Power = 4)->((Control_type = 0) and (Nominal_power = 3));

(Control_type = 2) -> (Nominal_power = 0) ;
(Control_type = 0) -> (Nominal_power = 3) ;
(Nominal_power = 3) -> (Control_type = 0)  ;

(Supply_voltage_and_frequency = 0)->(( Supply_voltage = 1) and ( Supply_frequency = 0)); 
(Supply_voltage_and_frequency = 1)->(( Supply_voltage = 0) and ( Supply_frequency = 0)); 
(Supply_voltage_and_frequency = 2)->(( Supply_voltage = 0) and ( Supply_frequency = 1)); 
(Supply_voltage_and_frequency = 3)->(( Supply_voltage = 1) and ( Supply_frequency = 1)); 
(Supply_voltage_and_frequency = 4)->(( Supply_voltage = 2) and ( Supply_frequency = 1)); 
(Supply_voltage_and_frequency = 5)->(( Supply_voltage = 3) and ( Supply_frequency = 1)); 

(
   ((Maximum_capacity = 0) and (Nominal_power = 0) and ( Pressure = 2) and ( Supply_frequency = 0))
or ((Maximum_capacity = 2) and (Nominal_power = 0) and ( Pressure = 1) and ( Supply_frequency = 0))
or ((Maximum_capacity = 10) and (Nominal_power = 0) and ( Pressure = 0) and ( Supply_frequency = 0))
or ((Maximum_capacity = 1) and (Nominal_power = 1) and ( Pressure = 3) and ( Supply_frequency = 0))
or ((Maximum_capacity = 4) and (Nominal_power = 1) and ( Pressure = 2) and ( Supply_frequency = 0))
or ((Maximum_capacity = 6) and (Nominal_power = 1) and ( Pressure = 1) and ( Supply_frequency = 0))
or ((Maximum_capacity = 11) and (Nominal_power = 1) and ( Pressure = 0) and ( Supply_frequency = 0))
or ((Maximum_capacity = 5) and (Nominal_power = 2) and ( Pressure = 3) and ( Supply_frequency = 0))
or ((Maximum_capacity = 7) and (Nominal_power = 2) and ( Pressure = 2) and ( Supply_frequency = 0))
or ((Maximum_capacity = 9) and (Nominal_power = 2) and ( Pressure = 1) and ( Supply_frequency = 0))
or ((Maximum_capacity = 9) and (Nominal_power = 2) and ( Pressure = 0) and ( Supply_frequency = 0))
or ((Maximum_capacity = 12) and (Nominal_power = 3) and ( Pressure = 3) and ( Supply_frequency = 0))
or ((Maximum_capacity = 13) and (Nominal_power = 3) and ( Pressure = 2) and ( Supply_frequency = 0))
or ((Maximum_capacity = 14) and (Nominal_power = 3) and ( Pressure = 1) and ( Supply_frequency = 0))
or ((Maximum_capacity = 15) and (Nominal_power = 3) and ( Pressure = 0) and ( Supply_frequency = 0))
or ((Maximum_capacity = 16) and (Nominal_power = 0) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 17) and (Nominal_power = 0) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 18) and (Nominal_power = 0) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 19) and (Nominal_power = 0) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 20) and (Nominal_power = 0) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 21) and (Nominal_power = 0) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 22) and (Nominal_power = 1) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 3) and (Nominal_power = 1) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 23) and (Nominal_power = 1) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 24) and (Nominal_power = 1) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 25) and (Nominal_power = 1) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 26) and (Nominal_power = 1) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 27) and (Nominal_power = 1) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 28) and (Nominal_power = 1) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 29) and (Nominal_power = 2) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 30) and (Nominal_power = 2) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 8) and (Nominal_power = 2) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 31) and (Nominal_power = 2) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 32) and (Nominal_power = 2) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 33) and (Nominal_power = 2) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 34) and (Nominal_power = 2) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 35) and (Nominal_power = 2) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 36) and (Nominal_power = 3) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 37) and (Nominal_power = 3) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 38) and (Nominal_power = 3) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 39) and (Nominal_power = 3) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 0) or (Supply_voltage = 1) ))
or ((Maximum_capacity = 40) and (Nominal_power = 3) and ( Pressure = 3) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 41) and (Nominal_power = 3) and ( Pressure = 2) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 42) and (Nominal_power = 3) and ( Pressure = 1) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))
or ((Maximum_capacity = 43) and (Nominal_power = 3) and ( Pressure = 0) and ( Supply_frequency = 1) and ((Supply_voltage = 2) or (Supply_voltage = 3) ))

);


(not ((Nominal_power = 0 ) and ( Pressure = 3)));

(Control_type = 0)->((Week_timer = 1) and (Communication_bus_RS485 = 1));
(Control_type = 2)-> (Communication_bus_RS485 = 0);
(Control_type = 2)-> (Integrated_refridgeration_air_dryer = 0);

(Integrated_refridgeration_air_dryer = 1) -> (( Water_draining_system = 0) or (Water_draining_system = 1));
(Oil_water_separator = 1) -> (Water_draining_system = 1);


