/* Reference :
Tiihonen, J., Soininen, T., Niemela, I., Sulonen, R.:
 Empirical testing of a weight constraint rule based configurator. 
In ECAI 2002 Configuration Workshop. (2002) 17--22 
http://www.soberit.hut.fi/pdmg/Empirical/index.html

 File: machine.pm
 Desc:  ILOG instance for MACHINE Benchmark
 Auth: Sathi
 Date: Mon July 14 2004
*/

variable
  public vari:[0..4];
  public toimitusmaa:[0..21];
  public nopeusluokka:[0..1];
  public voimanotto_kierrosnopeudet:[0..1];
  
  public etuakseli:[0..1];
  public etulokasuojat:[0..1];
  public takalokasuojat:[0..2];
  public taka_akeslin_mutasuojat:[0..1];
  public kattovilkku_present:[0..1];
  public kattovilkku_nonesome:[0..2];
  public etupainot_present:[0..1];
  public etupainot_nonesome:[0..2];
  public lisaetupainot_present:[0..1];
  public lisaetupainot_nonesome:[0..2];
  public etunostolaite_present:[0..1];
  public etunostolaite_nonesome:[0..2];
  public vetolaitteet:[0..1]; 
  public vetokoukku_perus_nonesome:[0..5];
  public vetokoukku_euro_nonesome:[0..5]; 
  public nopeuspoljin_taka:[0..1];
  public takahallimtalaittet:[0..1];
  public ohjaamo:[0..1];
  public vakioohjaamo_nonesome:[0..2];
  public metsaohjaamo_nonesome:[0..2];
  public sammutusvesisailio:[0..1];
  public rengaskoko:[0..8];
  
rule
(kattovilkku_present = 0)->(kattovilkku_nonesome = 0);
(kattovilkku_present <> 0)->(kattovilkku_nonesome <> 0);
(etupainot_present = 0) ->(etupainot_nonesome = 0);
(etupainot_present <> 0) ->(etupainot_nonesome <> 0);
(lisaetupainot_present = 0) ->(lisaetupainot_nonesome = 0);
(lisaetupainot_present <> 0) ->(lisaetupainot_nonesome <> 0);
(etunostolaite_present = 0) ->(etunostolaite_nonesome = 0);
(etunostolaite_present <> 0) ->(etunostolaite_nonesome <> 0);
(vetolaitteet = 0) -> ((vetokoukku_perus_nonesome <> 0) and (vetokoukku_euro_nonesome = 0 ));
(vetolaitteet <> 0) -> ((vetokoukku_perus_nonesome = 0) and (vetokoukku_euro_nonesome <> 0 ));
(ohjaamo = 0) -> ((vakioohjaamo_nonesome <> 0)and (metsaohjaamo_nonesome = 0));
(ohjaamo <> 0) -> ((vakioohjaamo_nonesome = 0)and (metsaohjaamo_nonesome <> 0));

(takahallimtalaittet = 1)-> (nopeuspoljin_taka = 1);
(not ( (rengaskoko = 2) and (takalokasuojat = 0) ));
(not ( (rengaskoko = 3) and (takalokasuojat = 0) ));
(nopeusluokka = 1 )-> ( (toimitusmaa = 0 ) or (toimitusmaa = 5 ) or (toimitusmaa = 7 ) or (toimitusmaa = 13 ) or (toimitusmaa = 14 ) or (toimitusmaa = 19 ) );
(not ((etupainot_present = 1) and ( lisaetupainot_present = 1 ) and (etunostolaite_present = 1) ));
( metsaohjaamo_nonesome <> 0) -> (nopeuspoljin_taka = 1);
(not ((etupainot_present = 1) and ( sammutusvesisailio = 1)));


